<script>
  import { onMount, createEventDispatcher } from "svelte";
  import { type as bType } from "@constants/button";

  export let title = null;
  export let type = null;
  export let loading = false;
  export let disabled = false;

  $: isDisabled = disabled === true;
  $: isLoading = loading === true;

  let bTitle;
  let bStyle;
  onMount(async () => {
    bTitle = (await title) ? title : "";
    bStyle = await `button ${type ? type : bType.primary}`;
  });

  const dispatch = createEventDispatcher();
  function onClick(event) {
    loading || disabled ? null : dispatch("click", event);
  }
</script>

<style>
  .button {
    font-family: Muli;
    font-size: 14px;
    font-weight: bold;
    text-decoration: none;
    border: none;
    border-radius: 500px;
    margin: 16px auto;
    width: 100%;
    cursor: pointer;
    outline: none;
    display: block;
    padding: 13px 10px;
    text-align: center;
    box-sizing: border-box;
  }

  button:disabled {
    color: #e1e1ed !important;
    background: #9ca4ac !important;
    pointer-events: none !important;
  }

  button.disabled {
    color: #e1e1ed !important;
    background: #9ca4ac !important;
    pointer-events: none !important;
  }

  .button.primary {
    background: red;
    border: 1px solid white;
    color: white;
  }

  .button.secondary {
    background: white;
    border: 1px solid red;
    color: red;
  }

  .button.transparent {
    background: transparent;
    border: none;
    color: red;
  }
</style>

<button
  class={bStyle}
  disabled={isDisabled}
  on:click={onClick}
  data-testid="button-tid">
  {#if !isLoading}
    {bTitle ? bTitle : ''}
  {:else}
    <div>
      <i class="spinner animate-spin" />
    </div>
  {/if}
</button>
